//
//  SOMAMoPubBannerAdapter.m
//  SmaatoShowcase
//
//  Created by Aman Shaikh on 02/09/14.
//  Copyright (c) 2014 Smaato Inc. All rights reserved.
//

#import "MPAdView.h"
#import "SOMAMoPubBannerAdapter.h"

@implementation SOMAMoPubBannerAdapter
- (void)requestAdWithSize:(CGSize)size customEventInfo:(NSDictionary *)info{
	
	self.somaBanner = [[SOMAAdView alloc] initWithFrame:CGRectMake(0, 0, size.width, size.height)];
	self.somaBanner.delegate = self;
	
	// change the key name as you've entered on MoPub dashboard
	self.somaBanner.adSettings.publisherId=[info[@"publisher"] intValue];
	self.somaBanner.adSettings.adSpaceId = [info[@"adspace"] intValue];
//	self.somaBanner.adSettings.autoReloadInterval = 0;
//	self.somaBanner.adSettings.autoReloadEnabled = NO;
	
    
    if ([[info allKeys] containsObject:@"pub"]) {
        self.somaBanner.adSettings.publisherId=[info[@"pub"] intValue];
    } else if ([[info allKeys] containsObject:@"publisher"]) {
        self.somaBanner.adSettings.publisherId=[info[@"publisher"] intValue];
    } else if ([[info allKeys] containsObject:@"publisherid"]) {
        self.somaBanner.adSettings.publisherId=[info[@"publisherid"] intValue];
    } else if ([[info allKeys] containsObject:@"publisherId"]) {
        self.somaBanner.adSettings.publisherId=[info[@"publisherId"] intValue];
    } else if ([[info allKeys] containsObject:@"PublisherId"]) {
        self.somaBanner.adSettings.publisherId=[info[@"PublisherId"] intValue];
    } else if ([[info allKeys] containsObject:@"PublisherID"]) {
        self.somaBanner.adSettings.publisherId=[info[@"PublisherID"] intValue];
    } else if ([[info allKeys] containsObject:@"publisherID"]) {
        self.somaBanner.adSettings.publisherId=[info[@"publisherID"] intValue];
    } else if ([[info allKeys] containsObject:@"Publisher"]) {
        self.somaBanner.adSettings.publisherId=[info[@"Publisher"] intValue];
    }
    
    if ([[info allKeys] containsObject:@"ad"]) {
        self.somaBanner.adSettings.adSpaceId=[info[@"ad"] intValue];
    } else if ([[info allKeys] containsObject:@"adspace"]) {
        self.somaBanner.adSettings.adSpaceId=[info[@"adspace"] intValue];
    } else if ([[info allKeys] containsObject:@"adspaceid"]) {
        self.somaBanner.adSettings.adSpaceId=[info[@"adspaceid"] intValue];
    } else if ([[info allKeys] containsObject:@"adspaceId"]) {
        self.somaBanner.adSettings.adSpaceId=[info[@"adspaceId"] intValue];
    } else if ([[info allKeys] containsObject:@"AdspaceId"]) {
        self.somaBanner.adSettings.adSpaceId=[info[@"AdspaceId"] intValue];
    } else if ([[info allKeys] containsObject:@"AdspaceID"]) {
        self.somaBanner.adSettings.adSpaceId=[info[@"AdspaceID"] intValue];
    } else if ([[info allKeys] containsObject:@"adspaceID"]) {
        self.somaBanner.adSettings.adSpaceId=[info[@"adspaceID"] intValue];
    } else if ([[info allKeys] containsObject:@"AdSpaceID"]) {
        self.somaBanner.adSettings.adSpaceId=[info[@"AdSpaceID"] intValue];
    } else if ([[info allKeys] containsObject:@"AdSpaceId"]) {
        self.somaBanner.adSettings.adSpaceId=[info[@"AdSpaceId"] intValue];
    } else if ([[info allKeys] containsObject:@"AdSpace"]) {
        self.somaBanner.adSettings.adSpaceId=[info[@"AdSpace"] intValue];
    } else if ([[info allKeys] containsObject:@"Ad"]) {
        self.somaBanner.adSettings.adSpaceId=[info[@"Ad"] intValue];
    }
    
//	self.somaBanner.adSettings.httpsOnly = YES;
	
	if (CGSizeEqualToSize(size, MOPUB_BANNER_SIZE)) {
		self.somaBanner.adSettings.dimension = SOMAAdDimensionDefault;
	} else if (CGSizeEqualToSize(size, MOPUB_MEDIUM_RECT_SIZE)) {
		self.somaBanner.adSettings.dimension = SOMAAdDimensionMedRect;
	} else if (CGSizeEqualToSize(size, MOPUB_LEADERBOARD_SIZE)) {
		self.somaBanner.adSettings.dimension = SOMAAdDimensionLeader;
	} else if (CGSizeEqualToSize(size, MOPUB_WIDE_SKYSCRAPER_SIZE)) {
		self.somaBanner.adSettings.dimension = SOMAAdDimensionSky;
	}
	
	self.somaBanner.adSettings.autoReloadEnabled = NO;
	
	[self.somaBanner load];
}

#pragma mark -
#pragma mark - SOMAAdViewDelegate
#pragma mark -

- (UIViewController *)somaRootViewController{
	return [self.delegate viewControllerForPresentingModalView];
}

- (void)somaAdViewDidLoadAd:(SOMAAdView *)adview{
	[self.delegate bannerCustomEvent:self didLoadAd:adview];
}
- (void)somaAdView:(SOMAAdView *)adview didFailToReceiveAdWithError:(NSError *)error{
	[adview removeFromSuperview];
	[self.delegate bannerCustomEvent:self didFailToLoadAdWithError:error];
}
- (BOOL)somaAdViewShouldEnterFullscreen:(SOMAAdView *)adview{
	[self.delegate bannerCustomEventWillBeginAction:self];
	return YES;
}

- (void)somaAdViewDidExitFullscreen:(SOMAAdView *)adview{
	[self.delegate bannerCustomEventDidFinishAction:self];
}

@end
