//
//  SOMAFacebookNativeCSMPlugin.m
//  iSoma
//
//  Created by Aman Shaikh on 11.05.16.
//  Copyright © 2016 Smaato Inc. All rights reserved.
//

#import "SOMAFacebookNativeCSMPlugin.h"
#import "SOMANativeAdDto.h"

static NSMutableDictionary* adChoicesViews = nil;
@interface SOMAFacebookNativeCSMPlugin()

@end

@implementation SOMAFacebookNativeCSMPlugin

- (void)load{
    if (adChoicesViews == nil) {
        adChoicesViews = [NSMutableDictionary new];
    }
    
	self.nativeAd = [[FBNativeAd alloc] initWithPlacementID:self.network.adunitid];
	self.nativeAd.delegate = self;
	[self.nativeAd loadAd];
}

- (void)registerViewForUserInteraction:(UIView*)view withRootViewController:(UIViewController*)rootViewController{
    UIView* tmp = adChoicesViews[[NSNumber numberWithUnsignedInteger:view.hash]];
    if (tmp) {
        [tmp removeFromSuperview];
        [adChoicesViews removeObjectForKey:[NSNumber numberWithUnsignedInteger:view.hash]];
    }
    
	FBAdChoicesView* adchoiseView = [[FBAdChoicesView alloc] initWithNativeAd:self.nativeAd];
	[view addSubview:adchoiseView];
	[adchoiseView updateFrameFromSuperview];
	[self.nativeAd registerViewForInteraction:view withViewController:rootViewController];
    
    adChoicesViews[[NSNumber numberWithUnsignedInteger:view.hash]] = adchoiseView;
}

- (void)nativeAdDidLoad:(FBNativeAd *)fbad{
	
	self.adCoverMediaView = [[FBMediaView alloc] initWithNativeAd:fbad];
	SOMANativeAdDTO* dto = [SOMANativeAdDTO new];
	dto.iconImageURL = fbad.icon.url;
	dto.callToAction = fbad.callToAction;
	dto.title = fbad.title;
	dto.text = fbad.body;
	dto.mediaView = self.adCoverMediaView;
	
	dto.starrating = 5*fbad.starRating.value/fbad.starRating.scale;
	
	[self.csmDelegate nativeCSMPluginDidLoad:self withDTO:dto];
}

- (void)nativeAd:(FBNativeAd *)nativeAd didFailWithError:(NSError *)error{
	[self.csmDelegate nativeCSMPluginDidFail:self];
}

- (void)nativeAdWillLogImpression:(FBNativeAd *)nativeAd{
	[self.csmDelegate nativeCSMPluginLogImpresion:self];
}

- (void)nativeAdDidClick:(FBNativeAd *)nativeAd{
	[self.csmDelegate nativeCSMPluginLogClick:self];
}
@end
