//
//  SMTLeaderboardAdViewController.m
//  iSomaDemo
//
//  Created by Aman Shaikh on 11/06/14.
//  Copyright (c) 2014 Smaato Inc. All rights reserved.
//

#import "SMTLeaderboardAdViewController.h"
#import <iSoma/iSoma.h>
#import "SMTAppSettings.h"

@interface SMTLeaderboardAdViewController ()<SOMAAdViewDelegate>

@end

@implementation SMTLeaderboardAdViewController
- (void)viewDidLoad{
	[super viewDidLoad];
}

#pragma mark -
#pragma mark - SOMAAdViewDelegate
#pragma mark -
- (UIViewController *)somaRootViewController{
    return self;
}
- (void)somaAdViewWillLoadAd:(SOMAAdView*)adview{
	NSLog(@"Ad View Will Load");
}

- (void)somaAdViewDidLoadAd:(SOMAAdView*)adview{
	NSLog(@"Ad View Loaded");
}

- (void)somaAdView:(SOMAAdView*)adview didFailToReceiveAdWithError:(NSError *)error{
	BOOL reloadEnabled = adview.adSettings.isAutoReloadEnabled;
	int reloadInterval = adview.adSettings.autoReloadInterval;
	NSString* reloadTimeMessage = @"";
	if (reloadEnabled) {
		reloadTimeMessage = [NSString stringWithFormat:@", in %d Seconds", reloadInterval];
	}
	NSLog(@"Ad View Failed to load: reloading:%@ %@", reloadEnabled == YES?@"YES":@"NO", reloadTimeMessage);
}

- (BOOL)somaAdViewShouldEnterFullscreen:(SOMAAdView*)adview{
	NSLog(@"Ad Clicked, will go fullscreen");
	return YES;
}

- (void)somaAdViewDidExitFullscreen:(SOMAAdView*)adview{
	NSLog(@"Exited full screen");
}
- (void)somaAdViewWillHide:(SOMAAdView*)adview{
	NSLog(@"Ad view will hide");
}
@end
